# coding: utf-8

"""
    perceptic-core-server API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1-SNAPSHOT
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from perceptic_core_client.models.info_event import InfoEvent
from perceptic_core_client.models.progress_event import ProgressEvent
from perceptic_core_client.models.request_for_input_event import RequestForInputEvent
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

WORKEREVENT_ONE_OF_SCHEMAS = ["InfoEvent", "ProgressEvent", "RequestForInputEvent"]

class WorkerEvent(BaseModel):
    """
    WorkerEvent
    """
    # data type: InfoEvent
    oneof_schema_1_validator: Optional[InfoEvent] = None
    # data type: ProgressEvent
    oneof_schema_2_validator: Optional[ProgressEvent] = None
    # data type: RequestForInputEvent
    oneof_schema_3_validator: Optional[RequestForInputEvent] = None
    actual_instance: Optional[Union[InfoEvent, ProgressEvent, RequestForInputEvent]] = None
    one_of_schemas: Set[str] = { "InfoEvent", "ProgressEvent", "RequestForInputEvent" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = WorkerEvent.model_construct()
        error_messages = []
        match = 0
        # validate data type: InfoEvent
        if not isinstance(v, InfoEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InfoEvent`")
        else:
            match += 1
        # validate data type: ProgressEvent
        if not isinstance(v, ProgressEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ProgressEvent`")
        else:
            match += 1
        # validate data type: RequestForInputEvent
        if not isinstance(v, RequestForInputEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RequestForInputEvent`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in WorkerEvent with oneOf schemas: InfoEvent, ProgressEvent, RequestForInputEvent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in WorkerEvent with oneOf schemas: InfoEvent, ProgressEvent, RequestForInputEvent. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `type` in the input.")

        # check if data type is `InfoEvent`
        if _data_type == "info":
            instance.actual_instance = InfoEvent.from_json(json_str)
            return instance

        # check if data type is `RequestForInputEvent`
        if _data_type == "input":
            instance.actual_instance = RequestForInputEvent.from_json(json_str)
            return instance

        # check if data type is `ProgressEvent`
        if _data_type == "progress":
            instance.actual_instance = ProgressEvent.from_json(json_str)
            return instance

        # check if data type is `InfoEvent`
        if _data_type == "InfoEvent":
            instance.actual_instance = InfoEvent.from_json(json_str)
            return instance

        # check if data type is `ProgressEvent`
        if _data_type == "ProgressEvent":
            instance.actual_instance = ProgressEvent.from_json(json_str)
            return instance

        # check if data type is `RequestForInputEvent`
        if _data_type == "RequestForInputEvent":
            instance.actual_instance = RequestForInputEvent.from_json(json_str)
            return instance

        # deserialize data into InfoEvent
        try:
            instance.actual_instance = InfoEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ProgressEvent
        try:
            instance.actual_instance = ProgressEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RequestForInputEvent
        try:
            instance.actual_instance = RequestForInputEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into WorkerEvent with oneOf schemas: InfoEvent, ProgressEvent, RequestForInputEvent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into WorkerEvent with oneOf schemas: InfoEvent, ProgressEvent, RequestForInputEvent. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], InfoEvent, ProgressEvent, RequestForInputEvent]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


